# Uses of Interface
org.apache.commons.math3.ml.distance.DistanceMeasure

Packages that use DistanceMeasure
Package
Description
org.apache.commons.math3.ml.clustering
Clustering algorithms.
org.apache.commons.math3.ml.clustering.evaluation
Cluster evaluation methods.
org.apache.commons.math3.ml.distance
Common distance measures.
org.apache.commons.math3.ml.neuralnet
Neural networks.
org.apache.commons.math3.ml.neuralnet.sofm
Self Organizing Feature Map.
org.apache.commons.math3.ml.neuralnet.twod.util
Utilities to visualize two-dimensional neural networks.

## Uses of DistanceMeasure in org.apache.commons.math3.ml.clustering

Methods in org.apache.commons.math3.ml.clustering that return DistanceMeasure
Modifier and Type
Method
Description
`DistanceMeasure`
Clusterer.`getDistanceMeasure()`
Returns the `DistanceMeasure` instance used by this clusterer.
Constructors in org.apache.commons.math3.ml.clustering with parameters of type DistanceMeasure
Modifier
Constructor
Description
`protected`
`Clusterer(DistanceMeasure measure)`
Build a new clusterer with the given `DistanceMeasure`.
``
`DBSCANClusterer(double eps, int minPts, DistanceMeasure measure)`
Creates a new instance of a DBSCANClusterer.
``
`FuzzyKMeansClusterer(int k, double fuzziness, int maxIterations, DistanceMeasure measure)`
Creates a new instance of a FuzzyKMeansClusterer.
``
`FuzzyKMeansClusterer(int k, double fuzziness, int maxIterations, DistanceMeasure measure, double epsilon, RandomGenerator random)`
Creates a new instance of a FuzzyKMeansClusterer.
``
`KMeansPlusPlusClusterer(int k, int maxIterations, DistanceMeasure measure)`
Build a clusterer.
``
`KMeansPlusPlusClusterer(int k, int maxIterations, DistanceMeasure measure, RandomGenerator random)`
Build a clusterer.
``
`KMeansPlusPlusClusterer(int k, int maxIterations, DistanceMeasure measure, RandomGenerator random, KMeansPlusPlusClusterer.EmptyClusterStrategy emptyStrategy)`
Build a clusterer.

## Uses of DistanceMeasure in org.apache.commons.math3.ml.clustering.evaluation

Constructors in org.apache.commons.math3.ml.clustering.evaluation with parameters of type DistanceMeasure
Modifier
Constructor
Description
``
`ClusterEvaluator(DistanceMeasure measure)`
Creates a new cluster evaluator with the given distance measure.
``
`SumOfClusterVariances(DistanceMeasure measure)`

## Uses of DistanceMeasure in org.apache.commons.math3.ml.distance

Classes in org.apache.commons.math3.ml.distance that implement DistanceMeasure
Modifier and Type
Class
Description
`class`
`CanberraDistance`
Calculates the Canberra distance between two points.
`class`
`ChebyshevDistance`
Calculates the L∞ (max of abs) distance between two points.
`class`
`EarthMoversDistance`
Calculates the Earh Mover's distance (also known as Wasserstein metric) between two distributions.
`class`
`EuclideanDistance`
Calculates the L2 (Euclidean) distance between two points.
`class`
`ManhattanDistance`
Calculates the L1 (sum of abs) distance between two points.

## Uses of DistanceMeasure in org.apache.commons.math3.ml.neuralnet

Methods in org.apache.commons.math3.ml.neuralnet with parameters of type DistanceMeasure
Modifier and Type
Method
Description
`static int[][]`
MapUtils.`computeHitHistogram(Iterable<double[]> data, NeuronSquareMesh2D map, DistanceMeasure distance)`
Computes the "hit" histogram of a two-dimensional map.
`static double`
MapUtils.`computeQuantizationError(Iterable<double[]> data, Iterable<Neuron> neurons, DistanceMeasure distance)`
Computes the quantization error.
`static double`
MapUtils.`computeTopographicError(Iterable<double[]> data, Network net, DistanceMeasure distance)`
Computes the topographic error.
`static double[][]`
MapUtils.`computeU(NeuronSquareMesh2D map, DistanceMeasure distance)`
Computes the U-matrix of a two-dimensional map.
`static Neuron`
MapUtils.`findBest(double[] features, Iterable<Neuron> neurons, DistanceMeasure distance)`
Finds the neuron that best matches the given features.
`static Pair<Neuron,Neuron>`
MapUtils.`findBestAndSecondBest(double[] features, Iterable<Neuron> neurons, DistanceMeasure distance)`
Finds the two neurons that best match the given features.
`static Neuron[]`
MapUtils.`sort(double[] features, Iterable<Neuron> neurons, DistanceMeasure distance)`
Creates a list of neurons sorted in increased order of the distance to the given `features`.

## Uses of DistanceMeasure in org.apache.commons.math3.ml.neuralnet.sofm

Constructors in org.apache.commons.math3.ml.neuralnet.sofm with parameters of type DistanceMeasure
Modifier
Constructor
Description
``
`KohonenUpdateAction(DistanceMeasure distance, LearningFactorFunction learningFactor, NeighbourhoodSizeFunction neighbourhoodSize)`

## Uses of DistanceMeasure in org.apache.commons.math3.ml.neuralnet.twod.util

Constructors in org.apache.commons.math3.ml.neuralnet.twod.util with parameters of type DistanceMeasure
Modifier
Constructor
Description
``
`HitHistogram(boolean normalizeCount, DistanceMeasure distance)`
``
`QuantizationError(DistanceMeasure distance)`
``
`SmoothedDataHistogram(int smoothingBins, DistanceMeasure distance)`
``
`TopographicErrorHistogram(boolean relativeCount, DistanceMeasure distance)`
``
`UnifiedDistanceMatrix(boolean individualDistances, DistanceMeasure distance)`
Simple constructor.